import { ethers } from 'ethers';
export declare const DelegateCash: {
    new (provider?: ethers.providers.Web3Provider | ethers.providers.JsonRpcProvider): {
        provider: ethers.providers.Web3Provider | ethers.providers.JsonRpcProvider;
        signer: ethers.Signer;
        delegationContract: ethers.Contract;
        checkDelegateForAll: (delegate: string, vault: string) => Promise<boolean>;
        checkDelegateForContract: (delegate: string, vault: string, contract: string) => Promise<boolean>;
        checkDelegateForToken: (delegate: string, vault: string, contract: string, tokenId: number) => Promise<boolean>;
        getContractLevelDelegations: (vault: string) => Promise<{
            contract: string;
            delegate: string;
        }[]>;
        getDelegatesForAll: (vault: string) => Promise<string[]>;
        getDelegatesForContract: (vault: string, contract: string) => Promise<string[]>;
        getDelegatesForToken: (vault: string, contract: string, tokenId: number) => Promise<string[]>;
        getDelegationsByDelegate: (delegate: string) => Promise<{
            type: 'NONE' | 'ALL' | 'CONTRACT' | 'TOKEN';
            vault: string;
            delegate: string;
            contract: string;
            tokenId: number;
        }[]>;
        getTokenLevelDelegations: (vault: string) => Promise<{
            contract: string;
            tokenId: number;
            delegate: string;
        }[]>;
        delegateForAll: (delegate: string, value: boolean) => Promise<any>;
        delegateForContract: (delegate: string, contract: string, value: boolean) => Promise<any>;
        delegateForToken: (delegate: string, contract: string, tokenId: number, value: boolean) => Promise<any>;
        revokeAllDelegates: () => Promise<any>;
        revokeDelegate: (delegate: string) => Promise<any>;
        revokeSelf: (vault: string) => Promise<any>;
    };
};
export declare const rawDelegateForAll: (delegate: string, value: boolean) => string;
export declare const rawDelegateForContract: (delegate: string, contract: string, value: boolean) => string;
export declare const rawDelegateForToken: (delegate: string, contract: string, tokenId: number, value: boolean) => string;
export declare const rawRevokeAllDelegates: () => string;
export declare const rawRevokeDelegate: (delegate: string) => string;
